'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _LinkButton = require('./LinkButton');

var _LinkButton2 = _interopRequireDefault(_LinkButton);

var _menu = require('./styles/menu');

var _menu2 = _interopRequireDefault(_menu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by guopeng on 16/3/28.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Menu = function (_Component) {
    _inherits(Menu, _Component);

    function Menu(props, context) {
        _classCallCheck(this, Menu);

        var _this = _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).call(this, props, context));

        var theme = _this._processTheme(props);
        _this.state = {
            ulStyle: theme.ul
        };
        return _this;
    }

    _createClass(Menu, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var props = this.props;
            var hide = props.hide;
            var _props$item = props.item;
            var item = _props$item === undefined ? [] : _props$item;
            var scope = props.scope;

            var _processTheme2 = this._processTheme(props);

            var container = _processTheme2.container;
            var getIcon = _processTheme2.getIcon;
            var li = _processTheme2.li;


            return _react2.default.createElement(
                'div',
                { className: 'navbar-menu', style: container },
                _react2.default.createElement(_LinkButton2.default, { icon: [getIcon(props.color), getIcon(props.highlightColor), getIcon(props.disabledColor)], scope: this, onClick: this._onMenuBtnClick.bind(this) }),
                _react2.default.createElement(
                    'ul',
                    { style: this.state.ulStyle },
                    item.map(function (item, idx) {
                        return _react2.default.createElement(
                            'li',
                            { key: 'navbar-menu-' + idx, style: li, onClick: _this2._onItemClick.bind(scope, item, _this2) },
                            item.text
                        );
                    })
                )
            );
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            _reactDom2.default.findDOMNode(this.props.scope).lastChild.addEventListener('click', this._contentClick.bind(this));
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            _reactDom2.default.findDOMNode(this.props.scope).lastChild.removeEventListener('click', this._contentClick.bind(this));
        }
    }, {
        key: '_processTheme',
        value: function _processTheme(props) {
            var theme = this.theme = (0, _menu2.default)();
            theme.container.display = props.hide ? 'none' : '';
            return theme;
        }

        //页面内容容器点击时触发事件, 隐藏menu弹出框

    }, {
        key: '_contentClick',
        value: function _contentClick() {
            if (this.state.ulStyle.display !== 'none') {
                this.setState({ "ulStyle": Object.assign({}, this.theme.ul, { display: "none" }) });
            }
        }

        //menu按钮点击事件

    }, {
        key: '_onMenuBtnClick',
        value: function _onMenuBtnClick() {
            if (this.state.ulStyle.display === 'none') {
                this.setState({ "ulStyle": Object.assign({}, this.theme.ul, { display: "block" }) });
            } else {
                this._hideMenuPop();
            }
        }
    }, {
        key: '_hideMenuPop',
        value: function _hideMenuPop() {
            this.setState({ "ulStyle": Object.assign({}, this.theme.ul, { display: "none" }) });
        }

        //菜单项点击处理

    }, {
        key: '_onItemClick',
        value: function _onItemClick(item, self) {
            if (item.onClick) {
                item.onClick.apply(this);
            }
            self._hideMenuPop();
        }
    }]);

    return Menu;
}(_react.Component);

exports.default = Menu;