'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _clone = require('clone');

var _clone2 = _interopRequireDefault(_clone);

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _WebDevNavBar = require('./WebDevNavBar');

var _WebDevNavBar2 = _interopRequireDefault(_WebDevNavBar);

var _NativeNavBar = require('./NativeNavBar');

var _NativeNavBar2 = _interopRequireDefault(_NativeNavBar);

var _WeixinNavBar = require('./WeixinNavBar');

var _WeixinNavBar2 = _interopRequireDefault(_WeixinNavBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created with WebStorm.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * User: gp
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Date: 16-2-2
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

//import immutable from 'immutable'


/**
 * NavBar 目前支持三种模式： webDevelop, native, 以微信为代表的嵌入式
 * webDevelop 目前不可配置，提供左侧返回按钮，中间标题，待需求和标准制定后添加可配置功能
 * native 只提供json配置，ui不作处理， 具体配置和功能待标准制定后添加 ,跳转时通知native改变导航栏
 * winxin 不提供ui，不提供配置。 目前只对页面标题功能作支持  ,控制右侧是否显示   ,isHide控制不了
 */
var NavigateBar = function (_Component) {
    _inherits(NavigateBar, _Component);

    function NavigateBar(props, context) {
        _classCallCheck(this, NavigateBar);

        var _this = _possibleConstructorReturn(this, (NavigateBar.__proto__ || Object.getPrototypeOf(NavigateBar)).call(this, props, context));

        _this.navOpt = props.config.navOpt;
        _this.env = props.env;
        return _this;
    }

    _createClass(NavigateBar, [{
        key: 'render',
        value: function render() {
            var _props = this.props;
            var config = _props.config;
            var env = _props.env;
            var scope = config.scope;

            var navOpt = this.navOpt;

            if (env == 'chanjet') {
                return _react2.default.createElement(_NativeNavBar2.default, { ref: 'bar', navOpt: navOpt, scope: scope });
            } else if (~['weixin', 'dingding'].indexOf(env)) {
                return _react2.default.createElement(_WeixinNavBar2.default, _extends({ ref: 'bar' }, config));
            } else {
                return _react2.default.createElement(_WebDevNavBar2.default, _extends({ ref: 'bar' }, navOpt, { scope: scope }));
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var scope = this.props.config.scope;
            scope.setNavbarInstance(this);
        }

        /**
         * 重新设置标题
         * @param title
         */

    }, {
        key: 'setTitle',
        value: function setTitle(title, cb) {
            this.updateProps({ title: title }, cb);
        }

        /**
         * 重新设置menu配置, 会重新更新menu展现和行为
         * @param menuCfg {JSONObject} menu配置, 只是item的配置
         */

    }, {
        key: 'setRightMenu',
        value: function setRightMenu(menuCfg, cb) {
            if (this.navOpt.right && this.navOpt.right.type === 'button') {
                throw new Error('右侧组件不能将一个按钮更改成菜单');
            }
            if (this.navOpt.right) {
                this.navOpt.right.item = [];
            }
            this.updateProps({ right: { item: menuCfg } });
        }

        /**
         * 重新设置右侧按钮配置, 会重新更新右侧按钮展现和行为
         * @param rightBtnCfg
         */

    }, {
        key: 'setRightButton',
        value: function setRightButton(rightBtnCfg, cb) {
            if (this.navOpt.right && this.navOpt.right.type === 'menu') {
                throw new Error('右侧组件不能将一个菜单更改成按钮');
            }
            this.updateProps({ right: { item: rightBtnCfg } });
        }

        /**
         * 显示右侧按钮或菜单
         */

    }, {
        key: 'showRight',
        value: function showRight(cb) {
            this.updateProps({ right: { hide: false } }, cb);
        }

        /**
         * 隐藏右侧按钮或菜单
         */

    }, {
        key: 'hideRight',
        value: function hideRight(cb) {
            this.updateProps({ right: { hide: true }, cb: cb });
        }

        /**
         * 启用右侧区域事件交互
         * @param cb
         */

    }, {
        key: 'enableRightUserInteraction',
        value: function enableRightUserInteraction(cb) {
            this.updateProps({ right: { userInteraction: true }, cb: cb });
        }

        /**
         * 停用右侧区域事件交互
         * @param cb
         */

    }, {
        key: 'disableRightUserInteraction',
        value: function disableRightUserInteraction(cb) {
            this.updateProps({ right: { userInteraction: false }, cb: cb });
        }
    }, {
        key: 'updateProps',
        value: function updateProps(navBarCfg, cb) {
            var _this2 = this;

            //this.navOpt = immutable.fromJS(this.navOpt).mergeDeep(navBarCfg).toJS();
            this.navOpt = (0, _deepmerge2.default)((0, _clone2.default)(this.navOpt), navBarCfg);
            this.setState({ ___dc: new Date().getTime() }, function () {
                _this2.noticeNative(_this2.navOpt, cb);
            });
        }
    }, {
        key: 'active',
        value: function active() {
            this.noticeNative();
        }
    }, {
        key: 'noticeNative',
        value: function noticeNative(opt, cb) {
            var env = this.env;
            if (this.env === 'chanjet') {
                this.refs.bar.noticeNative(cb);
            } else if (env === 'weixin') {
                this.refs.bar.noticeWeixin(opt);
            }
        }
    }, {
        key: 'executeNativeClick',
        value: function executeNativeClick(uri) {
            document.activeElement.blur();
            var scope = this.props.config.scope;
            if (!uri) return;
            var arr = uri.split('/');
            var len = arr.length;
            var navBar = this.navOpt;
            var i = len;

            var onClick = navBar;
            while (i > 0) {
                onClick = onClick[arr[len - i]];
                i--;
            }
            onClick.apply(scope);
        }
    }, {
        key: 'back',
        value: function back() {
            this.refs.bar.back();
        }
    }]);

    return NavigateBar;
}(_react.Component);

exports.default = NavigateBar;