'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _navBar = require('./styles/navBar');

var _navBar2 = _interopRequireDefault(_navBar);

var _LinkButton = require('./LinkButton');

var _LinkButton2 = _interopRequireDefault(_LinkButton);

var _Menu = require('./Menu');

var _Menu2 = _interopRequireDefault(_Menu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created with WebStorm.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * User: gp
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Date: 16-2-3
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

/**
 *  返回按钮和关闭按钮用户不可操控, 根据navationController中存放页面栈长度来确定返回显示不显示
 *  为1时不显示返回按钮, 其它显示
 */
var WebDevNavBar = function (_Component) {
    _inherits(WebDevNavBar, _Component);

    function WebDevNavBar() {
        _classCallCheck(this, WebDevNavBar);

        return _possibleConstructorReturn(this, (WebDevNavBar.__proto__ || Object.getPrototypeOf(WebDevNavBar)).apply(this, arguments));
    }

    _createClass(WebDevNavBar, [{
        key: 'render',


        /*constructor(props, context) {
            super(props, context);
        }*/

        value: function render() {

            //props包含导航栏配置和scope

            var props = this.props;

            var theme = this._processTheme(props);
            var navbar = theme.navbar;
            var navbarInner = theme.navbarInner;
            var leftBar = theme.leftBar;
            var center = theme.center;

            // scope Page实例对象

            var _props$scope = props.scope;
            var scope = _props$scope === undefined ? this : _props$scope;
            var rightButton = props.rightButton;
            var rightMenu = props.rightMenu;


            var rightEl = this._renderRightContent(props, theme);

            var propsColor = this._wrapColor(props);

            return _react2.default.createElement(
                'div',
                { className: 'navbar', style: navbar },
                _react2.default.createElement(
                    'div',
                    { className: 'navbar-inner', style: navbarInner },
                    _react2.default.createElement(
                        'div',
                        { className: 'left', style: leftBar },
                        !scope.isRootPage && _react2.default.createElement(_LinkButton2.default, { title: ['返回'], icon: this._wrapIcon('back', theme, props), color: propsColor, onClick: this.onBackBtnClicked.bind(this), iconStyle: { width: '0.32rem', height: '0.53333rem', marginRight: '0.266666rem' }, scope: scope }),
                        _react2.default.createElement(_LinkButton2.default, { title: ['关闭'], color: propsColor, onClick: this.onCloseBtnClicked.bind(this), iconStyle: { width: '0.32rem', height: '0.53333rem', marginRight: '0.266666rem' }, scope: scope })
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'center', style: center },
                        props.title
                    ),
                    rightEl
                )
            );
        }

        /**
         * 返回按钮操作
         */

    }, {
        key: 'onBackBtnClicked',
        value: function onBackBtnClicked() {
            // onNavBarLeftClick 左侧容器区域点击事件
            // scope Page实例对象
            var _props = this.props;
            var onBackClick = _props.onBackClick;
            var _props$scope2 = _props.scope;
            var scope = _props$scope2 === undefined ? this : _props$scope2;


            if (onBackClick) {
                onBackClick.apply(scope);
            } else {
                this._goBack();
            }
        }

        /**
         * 关闭按钮操作
         */

    }, {
        key: 'onCloseBtnClicked',
        value: function onCloseBtnClicked() {
            // onNavBarLeftClick 左侧容器区域点击事件
            // scope Page实例对象
            var _props2 = this.props;
            var onCloseClick = _props2.onCloseClick;
            var _props2$scope = _props2.scope;
            var scope = _props2$scope === undefined ? this : _props2$scope;


            if (onCloseClick) {
                onCloseClick.apply(scope);
            } else {
                this._closeWin();
            }
        }
    }, {
        key: '_closeWin',
        value: function _closeWin() {
            var win = window.open("about:blank", "_self");
            win.close();
        }
    }, {
        key: '_goBack',
        value: function _goBack() {
            history.go(-1);
        }

        /**
         * 处理渲染用到的inline style
         * @param props
         * @private
         */

    }, {
        key: '_processTheme',
        value: function _processTheme(props) {
            var hide = props.hide;
            var _props$left = props.left;
            var left = _props$left === undefined ? {} : _props$left;
            var _props$right = props.right;
            var right = _props$right === undefined ? {} : _props$right;
            var backgroundColor = props.backgroundColor;
            var height = props.height;
            var color = props.color;

            var theme = (0, _navBar2.default)({ backgroundColor: backgroundColor, height: height });

            theme['navbar'].display = hide ? 'none' : '';
            var navbar = theme.navbar;
            var leftBar = theme.leftBar;
            var rightBar = theme.rightBar;
            var center = theme.center;

            leftBar.visibility = left.hide ? 'hidden' : 'visible';
            rightBar.visibility = right.hide ? 'hidden' : 'visible';
            center.color = color;

            return theme;
        }

        /**
         * 渲染右侧内容
         * @param rightComponent {String|Array} 组件列表配置
         * @return {string}
         * @private
         */

    }, {
        key: '_renderRightContent',
        value: function _renderRightContent(props) {
            var theme = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

            return _react2.default.createElement(
                'div',
                { className: 'right', style: theme.rightBar },
                props.right && this._createRightComponent(props, theme)
            );
        }

        /**
         * 根据配置创建右侧容器内的组件
         * @param opt 组件json配置
         * @return {string}
         * @private
         */

    }, {
        key: '_createRightComponent',
        value: function _createRightComponent(props, theme) {
            var right = props.right;
            var scope = props.scope;


            var type = right.type;
            var item = right.item;

            if (type === 'button') {
                var opt = {
                    hide: right.hide,
                    color: this._wrapColor(props),
                    onClick: item.onClick,
                    disabled: item.disabled
                };
                var text = item.text;
                if (text && text.length > 0) {
                    opt.title = text;
                } else {
                    var iconType = item.icon;
                    opt.icon = this._wrapIcon(iconType, theme, props);
                }
                return _react2.default.createElement(_LinkButton2.default, _extends({}, opt, { scope: scope }));
            } else if (type === 'menu') {

                return _react2.default.createElement(_Menu2.default, _extends({}, right, { color: props.color, highlightColor: props.highlightColor, disabledColor: props.disabledColor, scope: scope }));
            } else {
                throw new Error('右侧容器内可以放置的组件类型目前只支持"button"和"menu"');
            }
        }
    }, {
        key: '_wrapIcon',
        value: function _wrapIcon(type, theme, props) {
            var color = props.color;
            var highlightColor = props.highlightColor;
            var disabledColor = props.disabledColor;

            return [theme.getIcon(type, color), theme.getIcon(type, highlightColor), theme.getIcon(type, disabledColor)];
        }
    }, {
        key: '_wrapColor',
        value: function _wrapColor(props) {
            return [props.color, props.highlightColor, props.disabledColor];
        }
    }]);

    return WebDevNavBar;
}(_react.Component);

exports.default = WebDevNavBar;