'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = getTheme;

var _colors = require('./colors');

var _linkButton = require('./linkButton');

var _linkButton2 = _interopRequireDefault(_linkButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created with WebStorm.
 * User: gp
 * Date: 16-2-22
 *
 */
function getTheme() {
    var preStyle = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var $color = _colors.color;
    var $navbarBg = preStyle.backgroundColor || _colors.bgColor;
    var $navbarBorderColor = _colors.boderColor;
    var $barHeight = preStyle.height || '1.173333rem';

    var _getLinkTheme = (0, _linkButton2.default)({ height: $barHeight });

    var link = _getLinkTheme.link;
    var icon = _getLinkTheme.icon;


    var theme = {

        color: $color,

        navbar: {
            height: $barHeight,
            width: '100%',
            boxSizing: 'border-box',
            fontSize: '0.453333rem',
            position: 'absolute',
            margin: 0,
            left: 0,
            top: 0,
            backgroundColor: $navbarBg,
            borderBottom: '0.026666rem solid ' + $navbarBorderColor,
            zIndex: '500'
        },

        navbarInner: {
            position: 'absolute',
            left: 0,
            top: 0,
            width: '100%',
            height: '100%',
            padding: '0 0.213333rem',
            boxSizing: 'border-box',
            display: '-webkit-flex',
            //display: 'flex',
            WebkitBoxPack: 'justify',
            WebkitAlignItems: 'center',
            WebkitBoxAlign: 'center',
            WebkitJustifyContent: 'space-between',
            justifyContent: 'space-between',
            MsFlexAlign: 'center',

            alignItems: 'center'
        },

        link: link,

        center: {
            WebkitAlignItems: 'center',
            WebkitBoxAlign: 'center',
            fontSize: '0.48rem',
            fontWeight: '500',
            textAlign: 'center',
            margin: 0,
            overflow: 'hidden',
            textOverflow: 'ellipsis',
            whiteSpace: 'nowrap',
            lineHeight: $barHeight,
            display: '-webkit-flex'
            //display: 'block'
        },

        side: {
            WebkitBoxPack: 'start',
            WebkitAlignItems: 'center',
            WebkitBoxAlign: 'center',
            flexShrink: 0,
            display: '-webkit-flex',
            //display: 'flex',
            alignItems: 'flex-start',
            height: $barHeight,
            width: '2.8rem'

        },

        rightBar: {

            //marginLeft: '0.266666rem',
            WebkitJustifyContent: 'flex-end',
            justifyContent: 'flex-end'
        },

        leftBar: {
            WebkitJustifyContent: 'flex-start',
            justifyContent: 'flex-start'
        },

        icon: icon,

        getIcon: function getIcon(type, color) {
            switch (type) {
                case 'add':
                    return '\'data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"  viewBox="0 0 60 61" version="1.1"> <title>添加</title> <desc>Created with Sketch.</desc> <defs/> <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"> <g id="添加" fill="' + color + '"> <path d="M28.5010416,29 L28.5010416,0.498958351 L31.5010416,0.498958351 L31.5010416,29 L60.0020833,29 L60.0020833,32 L31.5010416,32 L31.5010416,60.5010416 L28.5010416,60.5010416 L28.5010416,32 L0,32 L0,29 L28.5010416,29 Z"/> </g> </g> </svg>\'';

                case 'back':
                    return '\'data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"  viewBox="0 0 34 63" version="1.1">  <title>返回</title> <desc>Created with Sketch.</desc> <defs/> <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"> <g id="返回" transform="translate(3.000000, 2.000000)" stroke-width="3" stroke="' + color + '"> <path d="M30,0 L0,29.5 L29.972168,59.3432617"/> </g> </g> </svg>\'';

                case 'edit':
                    return '\'data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 56 59" version="1.1"> <title>编辑</title> <desc>Created with Sketch.</desc> <defs/> <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"> <g id="编辑" transform="translate(0.000000, 2.000000)" stroke="' + color + '" stroke-width="3"> <path d="M55,19.2457627 L55,57 L0,57 L0,2 L0,2 L35.190678,2" id="Rectangle-1"/> <path d="M20,34.5 L54.75,0" id="Path-8"/> </g> </g> </svg>\'';

                case 'share':
                    return '\'data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 64 57" version="1.1"><title>分享</title> <desc>Created with Sketch.</desc> <defs/> <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"> <g id="分享" stroke="' + color + '" stroke-width="3"> <path d="M57.7479167,39.2431641 L57.7479167,57 L0.747916703,57 L0.747916703,0 L30.7567058,0" id="Rectangle-1-Copy"/> <path d="M28.7479167,36.547666 C28.7479167,36.547666 29.9979167,12.797666 59.7479167,14.047666" id="Path-9"/> <path d="M48.7479167,2 L61.2391461,14.0083284 L50.9372593,28" id="Path-10"/> </g> </g> </svg>\'';

                case 'del':
                    return '\'data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 59 60" version="1.1"> <title>删除</title> <desc>Created with Sketch.</desc> <defs/> <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"> <g id="删除" transform="translate(0.000000, 2.000000)" stroke="' + color + '" stroke-width="3"> <path d="M0.474167099,6.56515423 L16.4331835,6.56515423 L23.0020489,0 L35.3176582,0 L42.0331118,6.71165958 L58.044391,6.71165958" id="Path-5"/> <path d="M51.7364622,14.5604167 L51.7364622,57.0869059 L6.27744579,57.0869059 L6.27744579,14.5 L6.27744579,14.5" id="Rectangle-2"/> <path d="M20.7856425,14.5 L20.9065441,47.9807454" id="Path-6"/> <path d="M36.2610523,14.5 L36.381954,47.9807454" id="Path-6-Copy"/> </g> </g> </svg>\'';

                case 'openLink':
                    return '\'data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 61 61" version="1.1"><title>浏览器打开连接</title> <desc>Created with Sketch.</desc> <defs/> <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"> <g id="浏览器打开连接" transform="translate(-6.000000, -7.000000)" stroke="' + color + '" stroke-width="3"> <path d="M46.2398307,5.31204815 C54.8848345,5.31204815 61.8929948,12.3161896 61.8929948,20.9660157 L61.8929948,35.2839843 C61.8929948,43.9294319 54.8867353,50.9379519 46.2398307,50.9379519 C37.5948269,50.9379519 30.5866667,43.9220521 30.5866667,35.2785483 L30.5866667,26.6588128" id="Rectangle-3" transform="translate(46.239831, 28.125000) scale(-1, -1) rotate(43.000000) translate(-46.239831, -28.125000) "/> <path d="M27.4931641,69.6879519 C18.8481603,69.6879519 11.84,62.6838104 11.84,54.0339843 L11.84,39.7160157 C11.84,31.0705681 18.8462595,24.0620481 27.4931641,24.0620481 C36.1381679,24.0620481 43.1463281,31.0645674 43.1463281,39.7138145 L43.1463281,48.4161545" id="Rectangle-3-Copy" transform="translate(27.493164, 46.875000) scale(-1, -1) rotate(43.000000) translate(-27.493164, -46.875000) "/> </g> </g> </svg>\'';

                /*case 'back':
                    return '\'data:image/svg+xml;charset=utf-8,   \''*/
            }

            return '';
        },

        ml10: {
            marginLeft: '0.266666rem'
        }
    };

    Object.assign(theme.rightBar, theme.side);
    Object.assign(theme.leftBar, theme.side);
    Object.assign({}, theme.icon, { width: '0.32rem', height: '0.533333rem' });

    return theme;
}