/**
 * Created by guopeng on 16/3/28.
 */
import React, { Component } from 'react';
import ReactDOM, {render} from 'react-dom';
import LinkButton from './LinkButton'
import getMenuTheme from './styles/menu'

class Menu extends Component {

    constructor(props,context) {
      super(props, context);
      const theme = this._processTheme(props);
      this.state = {
          ulStyle: theme.ul
      }
    }

    render() {
        const  props = this.props;
        const {hide,item=[], scope} = props;
        const {container, getIcon, li} = this._processTheme(props);

        return (
          <div className="navbar-menu" style={container}>
             <LinkButton icon={[getIcon(props.color),getIcon(props.highlightColor),getIcon(props.disabledColor)]} scope={this} onClick={this._onMenuBtnClick.bind(this)}></LinkButton>
             <ul style={this.state.ulStyle}>
                 {item.map( (item,idx) => <li key={`navbar-menu-${idx}`} style={li} onClick={this._onItemClick.bind(scope,item,this)}>{item.text}</li> )}
             </ul>
          </div>
        );

    }

    componentDidMount(){
        ReactDOM.findDOMNode(this.props.scope).lastChild.addEventListener('click',this._contentClick.bind(this));
    }

    componentWillUnmount(){
        ReactDOM.findDOMNode(this.props.scope).lastChild.removeEventListener('click',this._contentClick.bind(this));
    }

    _processTheme(props){
        var theme = this.theme = getMenuTheme();
        theme.container.display = props.hide?'none':'';
        return theme;
    }

    //页面内容容器点击时触发事件, 隐藏menu弹出框
    _contentClick() {
        if(this.state.ulStyle.display !== 'none'){
            this.setState({"ulStyle":Object.assign({},this.theme.ul,{display:"none"})});
        }

    }

    //menu按钮点击事件
    _onMenuBtnClick() {
        if(this.state.ulStyle.display === 'none'){
            this.setState({"ulStyle":Object.assign({},this.theme.ul,{display:"block"})});
        }else{
            this._hideMenuPop();
        }

    }

    _hideMenuPop(){
        this.setState({"ulStyle":Object.assign({},this.theme.ul,{display:"none"})});
    }

    //菜单项点击处理
    _onItemClick(item,self) {
       if(item.onClick){
           item.onClick.apply(this);
       }
       self._hideMenuPop();
    }
}

export default Menu;